function cStruct = RB_AlignMesh(cStruct)
deleteList = [];
warning off;

for i = 1:length(cStruct)
    
    % for i = 1:1
    coordList = zeros(14,3);
    coordList2 = zeros(14,3);
    
    for coordid = 1:14
        coordList(coordid,:) = RB_getCoordFromTable(cStruct(i).coordTable,coordid);
        if(coordList(coordid,1) > 10000)
            coordList(coordid,1) = 0;
        end
        if(coordList(coordid,2) > 10000)
            coordList(coordid,2) = 0;
        end
        if(coordList(coordid,3) > 10000)
            coordList(coordid,3) = 0;
        end
    end
    
    % Check for non valids
    if((norm(coordList(8,:)) < 0.001 && norm(coordList(9,:)) < 0.001))
        deleteList(end+1) = i;
    end
    
    
    rightOverrule = false;
    leftOverrule = false;
    if(norm(coordList(5,:)) > 0.001 && norm(coordList(6,:)) > 0.001)
    elseif(norm(coordList(5,:)) > 0.001)
        coordList(6,:) = coordList(5,:);
        rightOverrule = true;
    else
        coordList(5,:) = coordList(6,:);
        leftOverrule = true;
    end
    
    
    
    if(norm(coordList(8,:)) > 0.001 && norm(coordList(9,:)) > 0.001 && norm(coordList(8,:)) < 1e5 && norm(coordList(9,:)) < 1e5)
        
    elseif(norm(coordList(8,:)) > 0.001 && norm(coordList(8,:)) < 1e5)
        coordList(9,:) = coordList(8,:);
    else
        coordList(8,:) = coordList(9,:);
    end
    
    
    % Canthal line
    exoRight = coordList(4,:);
    exoLeft = coordList(3,:);
    exoDir = (exoLeft-exoRight) / norm(exoLeft-exoRight);
    
    r = vrrotvec2mat(vrrotvec(exoDir,[1 0 0]));
    [test,coordList] = RB_RotateObject(cStruct(i).mesh, coordList, r, exoRight);
    [test2,coordList2] = RB_RotateObject(cStruct(i).mesh, coordList2, r, exoRight);
    
    prp = mean(coordList(3:4,:));
    [test,coordList] = RB_TranslateObject(test, coordList, -prp);
    [test2,coordList2] = RB_TranslateObject(test2, coordList2, -prp);
    
    
    
    % Cantal line is rotation point now
    prp = mean(coordList(3:4,:));
    % fixationPoint = mean([coordList(5,:); coordList(6,:)]);
    fixationPoint = mean([coordList(5,:); coordList(6,:)]);
    
    a = fixationPoint(2:3);
    b = [0 1];
    theta = rad2deg(acos(min(1,max(-1, a(:).' * b(:) / norm(a) / norm(b) ))));
    
    if(a(1) < 0)
        theta = 360-theta;
    end
    theta = theta - 90;
    
    %  theta = theta - 10;
    r = [1 0 0 deg2rad(theta)];
    
    
    [test,coordList] = RB_RotateObject(test, coordList, vrrotvec2mat(r), prp);
    [test2,coordList2] = RB_RotateObject(test2, coordList2, vrrotvec2mat(r), prp);
    prp = mean(coordList(3:4,:));
    %%
    trachus_left =  coordList(8,:);
    trachus_right =  coordList(9,:);
    
    pc = pointCloud(test.vertices);
    
    [indicesl,~] = findNeighborsInRadius(pc,trachus_left,4);
    [indicesr,~] = findNeighborsInRadius(pc,trachus_right,4);
    
    
    % Find most lateral point
    if(rightOverrule)
        [~, lIdx] = max(test.vertices(indicesl,1));
    else
        [~, lIdx] = min(test.vertices(indicesl,1));
    end
    
    if(leftOverrule)
        [~, rIdx] = min(test.vertices(indicesr,1));
    else
        [~, rIdx] = max(test.vertices(indicesr,1));
    end

    if(isempty(lIdx))
         coordList(15,:) = trachus_left;
    else
         coordList(15,:) = test.vertices(indicesl(lIdx),:);
    end
     if(isempty(rIdx))
         coordList(16,:) = trachus_right;
    else
         coordList(16,:) = test.vertices(indicesr(rIdx),:);
     end
    coordList(15,:) = trachus_left;
     coordList(16,:) = trachus_right;

    
  
    rollVector = mean([coordList(8,:); coordList(9,:)]);
    rollVector = rollVector ./ norm(rollVector);
    a = rollVector([2 3]);
    b = [1 0];
    theta = rad2deg(acos(min(1,max(-1, a(:).' * b(:) / norm(a) / norm(b) ))));
    
    if(a(1) < 0)
        theta = 360-theta;
    end
    % theta = theta - 90;
    
    %  theta = theta - 10;
    r = [1 0 0 deg2rad(theta)];

    fixationPoint = mean([coordList(8,:); coordList(9,:)]);
    
    prp = mean(coordList(3:4,:));
    [test,coordList] = RB_TranslateObject(test, coordList, -[prp(1) fixationPoint(2) prp(3)]);
    [test2,coordList2] = RB_TranslateObject(test2, coordList2, -[prp(1) fixationPoint(2) prp(3)]);
    cStruct(i).coordsAligned = coordList;
    cStruct(i).mesh = test;
    [prp(1) fixationPoint(2) prp(3)]
    
end

cStruct(deleteList) = [];



warning on;
end