function [CranioStruct_out] = readAllOBJ_v3(CranioStruct_in,patchslim_bool,texture_bool)
% Functie gemaakt op 15-12-2015
% Load all OBJ files, including with or without texture
% Patchslim_bool to remove the double Vertices and Faces 1 = true, 0 = false
% Texture_bool to load texture 1 = true, 0 = false
CranioStruct_out = CranioStruct_in;
% % Allocate new struct:
% CranioStruct_out.name = CranioStruct_in.name;
% CranioStruct_out.photo_age = CranioStruct_in.photo_age;
% CranioStruct_out.born = CranioStruct_in.born;

% Function for loading BMP file:

    function [tvalue_size] = display_obj_simple(v,vt,fv,fvt,bmp_path)
        texture = imread(bmp_path);
        texture_img = flip(texture,1);
        [sy,sx,sz] = size(texture_img);
        texture_img =  reshape(texture_img,sy*sx,sz);

        % make image 3D if grayscale
        if sz == 1
            texture_img = repmat(texture_img,1,3);
        end

        % select what texture correspond to each vertex according to face
        % definition
        [~,fv_idx] = unique(fv);
        texture_idx = fvt(fv_idx);

        x = abs(round(vt(:,1)*(sx-1)))+1;
        y = abs(round(vt(:,2)*(sy-1)))+1;
        xy = sub2ind([sy sx],y,x);
    
        if texture_idx(1)==0
            texture_idx(1)=1;
            disp('Geen idee waarom dit ineens o is?')
        end
    
        texture_pts = xy(texture_idx);        
        tvalue = double(texture_img(texture_pts,:))/256;
        % If there are fewer texture points than vertices: tvalue < v
        % Fill texture points with zeros:
        tvalue_size = zeros(size(v));
        tvalue_size(1:length(tvalue),:) = tvalue;
    end

    function [vertex,faces,vertex_txt,faces_txt] = FastReadOBJ(filename)
        %  Functie aangepast van read_obj_3DMDpatient
        
        
        fid = fopen(filename);
        if fid<0

            error(['Cannot open ' filename '.']);
        end

        frewind(fid);
        vertex = [];
        vertex_txt = [];
        faces = [];
        faces_txt = [];

        while 1
            s = fgetl(fid);
            if ~ischar(s), 
                break;
            end
%             if ~isempty(s) && strcmp(s(1), 'f');
%                 
%                 % Face gevonden, evaluate line:
%                 alle9 = sscanf(s(3:end), '%d/%d/%d %d/%d/%d %d/%d/%d');
%                 
%                 if size(alle9,1) == 9;
%                     faces(:,end+1) = alle9([1,4,7],1);
%                     faces_txt(:,end+1) = alle9([2,5,8],1);
%                 elseif size(alle9,1) == 12;
%                     % In dit geval bestaat een face uit 4 vertex punten:
%                     % Gebruik er dan toch 3..
%                     faces(:,end+1) = alle9([1,4,7],1);
%                     faces_txt(:,end+1) = alle9([2,5,8],1);
%                 elseif size(alle9,1) == 1;
%                     % Vermoedelijk opbouw van f 1//1 2//2 3//3
%                     X = sscanf(s(3:end), '%d//%d %d//%d %d//%d');
%                     faces(:,end+1) = X([1,3,5]);
%                 else
%                     disp('Did Not Found Right Dimensions of Face data');
%                 end
%                 
%             end

            if ~isempty(s) && strcmp(s(1), 'f');
                
                % Face gevonden, evaluate line:
                alle9 = sscanf(s(3:end), '%d/%d/%d %d/%d/%d %d/%d/%d');
                alle9 = sscanf(s(3:end), '%d/%d %d/%d %d/%d');
                
                if size(alle9,1) == 6;            
                    faces(:,end+1) = alle9([1,3,5],1);
                    faces_txt(:,end+1) = alle9([2,4,6],1);
                elseif size(alle9,1) == 9
                    faces(:,end+1) = alle9([1,4,7],1);
                    faces_txt(:,end+1) = alle9([2,5,8],1);
                    
                elseif size(alle9,1) == 12;
                    % In dit geval bestaat een face uit 4 vertex punten:
                    % Gebruik er dan toch 3..
                    faces(:,end+1) = alle9([1,4,7],1);
                    faces_txt(:,end+1) = alle9([2,5,8],1);
                elseif size(alle9,1) == 1;
                    % Vermoedelijk opbouw van f 1//1 2//2 3//3
                    X = sscanf(s(3:end), '%d//%d %d//%d %d//%d');
                    faces(:,end+1) = X([1,3,5]);
                else
                    disp('Did Not Found Right Dimensions of Face data');
                end

            end

            if ~isempty(s) && strcmp(s(1), 'v') && strcmp(s(2), ' ')
                % vertex gevonden, evaluate line:
                vertex(:,end+1) = sscanf(s(3:end), '%f %f %f');
            end
            
            if ~isempty(s) && strcmp(s(1), 'v') && strcmp(s(2), 't')
                % vertex gevonden, evaluate line:
                vertex_txt(:,end+1) = sscanf(s(3:end), '%f %f');
            end
            
        end
        fclose(fid);
    end

    function [Rawdata] = ReadRaw2(PathName)
% Function reads the data from a *.RAW file and put in matrix A (output)
    
    if exist(PathName, 'file')

        clear fid name
        name = PathName;
        fid = fopen(name);
        q = 1;
        line = fgets(fid);
        clear A

        while ischar(line)
            A(q,:) = str2num(line);
            q = q+1;
            line = fgets(fid);
        end

        Rawdata = A;
        disp(' RAW File loaded')

    else
        disp(' No RAW File with similar name')
        Rawdata= [];
    end
    end
    
    
   
 % ------------------------------------------------------------------------   
 


disp(' ')

if patchslim_bool == 1;
    disp(' Double Faces and Vertices will be removed');
elseif patchslim_bool == 0;
    disp(' Double Faces and Vertices will NOT be removed');
else
    disp(' Patchslim error');
    patchslim_bool = 0;
end

if texture_bool == 0;
    disp(' Texture will NOT be loaded');
end


disp(' ');

for k = 1: size(CranioStruct_in,2)
%for k = 1:1    
    % Remove texture location file if bool == 0
    if texture_bool == 0;
        CranioStruct_in(k).bmpPath = [];
    end
    
    if(exist(CranioStruct_in(k).csvPath, 'file'))
           disp(' -------------------------------')
        disp([' Patient ',num2str(k),'/',num2str(size(CranioStruct_in,2)),': ',CranioStruct_in(k).name])
        disp(' Coordinate Data Found')
        
        opts = detectImportOptions(CranioStruct_in(k).csvPath,'NumHeaderLines',0);
        CranioStruct_out(k).coordTable = readtable(CranioStruct_in(k).csvPath, opts);
        
%         % hacky hacky
%       hackPath = 'C:\Users\robin\Desktop\results\Trachus_5.0';
%         [~, fileName, ~] = fileparts(CranioStruct_in(k).csvPath);
%         totalTable = readtable(CranioStruct_in(k).csvPath, opts);
%         tempFile = readtable(fullfile(hackPath, [fileName '.csv']), opts);
%         totalTable(8:9,:) = tempFile(1:2,:);
%          CranioStruct_out(k).coordTable = totalTable;
    end
    
    % Check if .BMP file exists    
    if exist( CranioStruct_in(k).bmpPath, 'file')
        disp(' -------------------------------')
        disp([' Patient ',num2str(k),'/',num2str(size(CranioStruct_in,2)),': ',CranioStruct_in(k).name])
        disp(' Image Data Found')
        
        % FAST OBJ importer, imports vertex texture points:
        [v,f,v_txt,f_txt] = FastReadOBJ(CranioStruct_in(k).objPath);      
        % Import the BMP file and find vertex colors:
        Texture_values = display_obj_simple(v',v_txt',f',f_txt',CranioStruct_in(k).bmpPath);
        % Import Landmarks:
        Landmarks = ReadRaw2(CranioStruct_in(k).rawPath);
%         Landmarks2 = ReadRaw2(CranioStruct_in(k).rawPath);
%         Landmarks3 = ReadRaw2(CranioStruct_in(k).rawPath);
              
        if patchslim_bool == 1
            % Apply PatchSlim to remove doubles:
            [V, F]=patchslim(v',f');
        else
            V = v';
            F = f';
        end
        
        disp([' vertices: ',num2str(size(V,1)),'  faces: ',num2str(size(F,1))])
        
        CranioStruct_out(k).mesh.faces = F;
        CranioStruct_out(k).mesh.vertices = V;
        CranioStruct_out(k).mesh.texture = Texture_values;
        CranioStruct_out(k).mesh.landmarks = Landmarks;
%         CranioStruct_out(k).Landmarks2 = Landmarks2;
%         CranioStruct_out(k).Landmarks3 = Landmarks3;
        clear v f v_txt f_txt V F Texture_values 
    else
        
        % In case no BMP file is found, use fast OBJ importer
        disp(' -------------------------------')
        disp([' Patient ',num2str(k),'/',num2str(size(CranioStruct_in,2)),': ',CranioStruct_in(k).name])
        disp(' No Image Data')    
        
        % FAST OBJ importer, imports vertex texture points:
        [v,f,~,~] = FastReadOBJ(CranioStruct_in(k).objPath);      
       
        % Import Landmarks:
        Landmarks = ReadRaw2(CranioStruct_in(k).rawPath);
              
        if patchslim_bool == 1
            % Apply PatchSlim to remove doubles:
            [V, F]=patchslim(v',f');
        else
            V = v';
            F = f';
        end
        
        disp([' vertices: ',num2str(size(V,1)),'  faces: ',num2str(size(F,1))])
        CranioStruct_out(k).mesh.faces = F;
        CranioStruct_out(k).mesh.vertices = V;
        % Anders loopt ie later bij functies stuk, nog aanpasses:
%         CranioStruct_out(k).mesh.texture = [];
        CranioStruct_out(k).mesh.landmarks = Landmarks;
        clear v f V F
        
    end   
    
end
    CranioStruct_out = rmfield(CranioStruct_out,{'objPath','bmpPath','rawPath'});
    disp('  ')
    disp(' Completed')
    disp('  ')       
end